package com.jasamedika.medifirst2000.service.impl;

import com.jasamedika.medifirst2000.dao.JumlahDiskonDokterDao;
import com.jasamedika.medifirst2000.dto.JumlahDiskonDokterDto;
import com.jasamedika.medifirst2000.entities.JumlahDiskonDokter;
import com.jasamedika.medifirst2000.service.JumlahDiskonDokterService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;

/**
 * @author salmanoe
 * @version 1.0.0
 * @since 07/02/2024
 */
@Service
@Transactional
public class JumlahDiskonDokterServiceImpl implements JumlahDiskonDokterService {

	@Autowired
	private JumlahDiskonDokterDao jumlahDiskonDokterDao;

	@Override
	public void save(List<JumlahDiskonDokterDto> dtos) {
		List<JumlahDiskonDokter> entities = new ArrayList<>();
		dtos.forEach(
				dto -> entities.add(JumlahDiskonDokter.builder().persenDiskon(new BigDecimal(dto.getPersenDiskon()))
						.statusEnabled(dto.getStatusEnabled()).kdProfile((short) 0).build()));
		jumlahDiskonDokterDao.save(entities);
	}
}
